## 前端导入数据库表定义

在 boot/next.js 中加入数据库表定义的目录:

```javascript
var loadChatFramework = function () {
			util.loadDir(["pi/lang/", "pi/net/", "pi/ui/", "pi/util/","pi/components/", "数据库表定义目录"], flags, fm, undefined, function (fileMap) {
				registerChatStruct()
			}, function (r) {
				alert("加载目录失败, " + r.error + ":" + r.reason);
			}, dirProcess.handler);
		}
```

## 例子

访问： http://127.0.0.1/management/boot/index.html

以下示例都是在浏览器命令行窗口中运行, 导出的接口都在 client/net/rpc.ts 中

1. 设置测试数据库表的数据

```js
setUpTestDb()
```

调用这个函数会往 "management/server/data/db/user.User" 表中写入100条数据用于后续测试

2. 获取一个库的所有表

```js
getTabs("file")
getTabs("memory")
```

分别获取文件数据库和内存数据库中的所有表

3. 获取一个表的元信息

```js
getMetaInfo("file", "management/server/data/db/user.User")
```

4. 读取数据

```js
dbRead("file", "management/server/data/db/user.User", [1,2,3,4,5]) 
```

5. 写入数据

参照 `setUpTestDb()` 的实现


6. 删除数据

```js
dbWrite("file", "management/server/data/db/user.User", [1,2,3], [undefined, undefined, undefined])
```
删除三条数据


7. 迭代数据

为了避免迭代时传输的数据过大，迭代数据是分页的，推荐一次迭代10个数据

升序迭代:
```js
dbIter("file", "management/server/data/db/user.User", 10, 0, 5, true)
```
从主键0到主键5，最多10个数据

```js
dbIter("file", "management/server/data/db/user.User", 10, undefined, undefined, true)
```
`startKey` 的参数为 `undefined`表示从表的第一条记录开始迭代 10 个数据

降序迭代:
```js
dbIter("file", "management/server/data/db/user.User", 10, 5, 0, false)
dbIter("file", "management/server/data/db/user.User", 10, undefined, undefined, false)
```



