import { Widget } from '../../../../pi/widget/widget';

import { popNew } from '../../../../pi/ui/root';
import { BonBuffer } from '../../../../pi/util/bon';
import { newValueFromJsonString } from '../../../utils/util';
import { iterDb, writeDb } from '../../net/rpc';
import { equal } from './app';

declare var pi_modules;

export class DbTable extends Widget {
    public ok:(v: any) => void;
    public prevPageKey: any;
    constructor() {
        super();
    }

    public modify(e: any) {
        const [modName, expt] = this.props.tab.split('.');
        const t = pi_modules[modName + '.s'].exports[expt];
        const primaryKey = t._$info.notes.get('primary');

        popNew('management-client-app-base-modify',null,value => {
            if (!value) {
                popNew('pi-components-message-message', { type: 'success', content: 'value不能为空', center: true });
                return;
            }
            const x = newValueFromJsonString(t, value);
            writeDb('file', this.props.tab, [x[primaryKey]], [x], r => {
                if (r && r.code === 1) {
                    popNew('pi-components-message-message', { type: 'success', content: '修改成功', center: true });
                    this.props.datas[e.index][1] = value;
                    this.paint();
                } else {
                    popNew('pi-components-message-message', { type: 'success', content: '修改失败', center: true });
                }
            });
        });
    }

    public delete(e: any) {
        const kv = this.props.datas[e.index];
        const kvobj = JSON.parse(kv[1]);
        const primary = kvobj[this.props.primaryKey];

        writeDb('file', this.props.tab, [primary], [undefined], r => {
            if (r.code === 1) {
                popNew('pi-components-message-message', { type: 'success', content: '删除成功', center: true });
                this.props.datas.splice(e.index, 1);
                this.paint();
            } else {
                popNew('pi-components-message-message', { type: 'success', content: '删除失败', center: true });
            }
        });  
    }

    public prevPage(e: any) {
        if (this.props.recentKey) {
            iterDb('file', this.props.tab, 10, this.props.recentKey, undefined, false, r => {
                const [modName, expt] = this.props.tab.split('.');
                const t = pi_modules[modName + '.s'].exports[expt];
                const primaryKey = t._$info.notes.get('primary');

                const bon1 = new BonBuffer(r.msg);
                const values = bon1.readArray(() => {
                    const bin = bon1.readBin();
                    // undefined 序列化为 0
                    if (equal(bin.buffer, new Uint8Array([0]).buffer)) {
                        return null;
                    }
                    // 解析数据表
                    const b = new BonBuffer(bin);
                    const m = new t();
                    m.bonDecode(b);
                    return m;
                });

                if (values) {
                    values.splice(0, 1);
                }
                for (const v of values.reverse()) {
                    this.props.datas.push([v[primaryKey], JSON.stringify(v)]);
                }
                this.paint();
                if (values.length) {
                    this.props.recentKey = values[0][primaryKey];
                } else {
                    this.props.recentKey = null;
                }
            });
        } else {
            this.ok && this.ok({});
        }     
    }

    public nextPage(e: any) {
        if (this.props.recentKey) {
            iterDb('file', this.props.tab, 10, this.props.recentKey, undefined, true, r => {
                console.log('code', r.code);
                const [modName, expt] = this.props.tab.split('.');
                const t = pi_modules[modName + '.s'].exports[expt];
                const primaryKey = t._$info.notes.get('primary');

                const bon1 = new BonBuffer(r.msg);
                const values = bon1.readArray(() => {
                    const bin = bon1.readBin();
                    // undefined 序列化为 0
                    if (equal(bin.buffer, new Uint8Array([0]).buffer)) {
                        return null;
                    }
                    // 解析数据表
                    const b = new BonBuffer(bin);
                    const m = new t();
                    m.bonDecode(b);
                    return m;
                });

                values.splice(0, 1);
                for (const v of values) {
                    this.props.datas.push([v[primaryKey], JSON.stringify(v)]);
                }
                this.paint();
                if (values.length) {
                    this.props.recentKey = values[values.length - 1][primaryKey];
                } else {
                    this.props.recentKey = null;
                }
            });
        } else {
            this.ok && this.ok({});
        }       
    }
}
