/**
 * 默认数据库
 */

// ================================================ 导入
import { popNew } from '../../../../pi/ui/root';
import { Forelet } from '../../../../pi/widget/forelet';
import { Widget } from '../../../../pi/widget/widget';

// ================================================ 导出
export const forelet = new Forelet();

interface Props {
    activePage: any;  // 当前活跃的页面
    pageList: any[]; // 默认过滤器
    rightBox:boolean;  // 是否显示rightbox页面
}
const PAGE = {
    database: 'database', // 数据库
    shell: 'shell', // shell查询
    rpc: 'rpc', // rpc操作
    log: 'log',  // 日志查看
    syestem: 'system' // 系统设置
};

// tslint:disable-next-line:completed-docs
export class Home extends Widget {
    public ok: () => void;
    public props: Props;
    public state:any;
    constructor() {
        super();
        this.props = {
            pageList: [
                { name: '数据库', page: PAGE.database },
                { name: 'SHELL查询', page: PAGE.shell },
                { name: 'rpc操作', page: PAGE.rpc },
                { name: '日志查看', page: PAGE.log },
                { name: '系统设置', page: PAGE.syestem }
            ],
            activePage: {},
            rightBox:true
        };
        this.changePage(0);
    }
    // 切换默认过滤器页面
    public changePage(num?: number) {
        if (num >= 0) {
            this.props.activePage = this.props.pageList[num];
        }
        this.paint();
    }
}