import { Widget } from "../../../../pi/widget/widget";
import { popNew } from "../../../../pi/ui/root";

import { writeDb} from "../../net/rpc";
import { newValueFromJsonString, newPrimaryKeyType } from '../../../utils/util';

declare var pi_modules;

export class Range extends Widget {
    public ok:(v: any) => void;

    constructor() {
        super();
        this.state = {
            insertKey: "",
            insertValue: "",
        }
    }

    public inputInsertKey(e: any) {
        this.state.insertKey = e.value;
    }

    public inputInsertValue(e: any) {
        this.state.insertValue = e.value;
    }

    public insertData(e: any) {
        let tab = this.props.tables[this.props.index][0];
        let [modName, expt] = tab.split(".");
        let t = pi_modules[modName + ".s"].exports[expt];
        let key = newPrimaryKeyType(t._$info, this.state.insertKey);
        let value = newValueFromJsonString(t, this.state.insertValue);

        // TODO
        writeDb("file", tab, [key], [value], r => {
            console.log(r);
            if (r.code === 1) {
                popNew("pi-components-message-message", { type: "success", content: "插入成功", center: true });
            } else {
                popNew("pi-components-message-message", { type: "fail", content: "插入失败", center: true });
            }
        });
    }

    public cancelInsert(e: any) {
        this.ok && this.ok({})
    }
}
