import { Widget } from "../../../../pi/widget/widget";
import { popNew } from "../../../../pi/ui/root";

import { iterDb } from "../../net/rpc";
import { BonBuffer } from '../../../../pi/util/bon';
import { equal } from './app';
import { newPrimaryKeyType } from '../../../utils/util';

declare var pi_modules;

export class Range extends Widget {
    public ok:(v: any) => void;

    constructor() {
        super();
        this.state = {
            startKey: "",
            endKey: "",
        }
    }

    public inputStartKey(e: any) {
        // console.log("inputStartKey111: ", e.value);
        this.state.startKey = e.value;
    }

    public inputEndKey(e: any) {
        // console.log("inputEndKey222: ", e.value);
        this.state.endKey = e.value;
    }

    public fetchRecords(e: any) {
        const startKey =  this.state.startKey;
        const endKey = this.state.endKey;
        const tab = this.props.tables[this.props.index][0];

        let [modName, expt] = tab.split(".");
        let t = pi_modules[modName + ".s"].exports[expt];
        let primaryKey = t._$info.notes.get("primary");

        let sk = newPrimaryKeyType(t._$info, startKey);
        let ek = newPrimaryKeyType(t._$info, endKey);

        iterDb("file", tab, 10, sk, ek, true, r => {
            let bon1 = new BonBuffer(r.msg);
            let values = bon1.readArray(() => {
                let bin = bon1.readBin();
                // undefined 序列化为 0
                if(equal(bin.buffer, new Uint8Array([0]).buffer)) {
                    return null;
                }
                // 解析数据表
                let b = new BonBuffer(bin);
                let m = new t();
                m.bonDecode(b);
                return m;
            });
            let datas = [];
            for(let v of values) {
                datas.push([v[primaryKey], JSON.stringify(v)]);
            }

            let recentKey;
            if (datas.length){
                recentKey = datas[datas.length - 1][0];
            } else {
                recentKey = null;
            }

            if(r.code === 1) {
                popNew("management-client-app-base-rangetable", {tab: tab, recentKey: recentKey, startKey: sk, endKey: ek, datas:datas,title:["key", "value", "操作"], maxHeight: 2000});
            } else {
                popNew("pi-components-message-message", { type: "fail", content: values, center: true });
            }

            this.ok && this.ok({});
        });
    }
}
