import { Widget } from "../../../../pi/widget/widget";
import { iterDb, writeDb } from "../../net/rpc";
import { popNew } from "../../../../pi/ui/root";
import { BonBuffer } from '../../../../pi/util/bon';
import { equal } from './app';

declare var pi_modules;


export class DbTable extends Widget {
    public ok:(v: any) => void;
    public dataSegs: any[];

    constructor() {
        super();
    }

    public modify(e: any) {
        popNew("management-client-app-base-modify",null,value => {
            if (!value) {
                popNew("pi-components-message-message", { type: "success", content: "value不能为空", center: true });
                return;
            }
            writeDb("file", this.props.tab, [this.props.datas[e.index][0]], [value], r => {
                if(r && r.code === 1) {
                    popNew("pi-components-message-message", { type: "success", content: "修改成功", center: true });
                    this.props.datas[e.index][1] = value;
                    this.paint();
                } else {
                    popNew("pi-components-message-message", { type: "success", content: "修改失败", center: true });
                }
            });
        })
    }

    public delete(e: any) {
        const kv = this.props.datas[e.index];

        writeDb("file", this.props.tab, [kv[0]], [undefined], r => {
            if(r.code === 1) {
                popNew("pi-components-message-message", { type: "success", content: "删除成功", center: true });
                this.props.datas.splice(e.index, 1);
                this.paint();
            } else {
                popNew("pi-components-message-message", { type: "success", content: "删除失败", center: true });
            }
        });  
    }

    public prevPage(e: any) {
        if (this.props.recentKey) {
            iterDb("file", this.props.tab, 10, this.props.recentKey[0], this.props.startKey, false, r => {
                console.log("code", r.code);
                let [modName, expt] = this.props.tab.split(".");
                let t = pi_modules[modName + ".s"].exports[expt];
                let primaryKey = t._$info.notes.get("primary");

                let bon1 = new BonBuffer(r.msg);
                let values = bon1.readArray(() => {
                    let bin = bon1.readBin();
                    // undefined 序列化为 0
                    if(equal(bin.buffer, new Uint8Array([0]).buffer)) {
                        return null
                    }
                    // 解析数据表
                    let b = new BonBuffer(bin);
                    let m = new t();
                    m.bonDecode(b);
                    return m;
                });

                console.log(values);

                if (values) {
                    values.splice(0, 1);
                }
                for(let v of values.reverse()) {
                    this.props.datas.push([v[primaryKey], JSON.stringify(v)]);
                }
                this.paint();
                if (values.length){
                    this.props.recentKey = values[0][primaryKey];
                } else {
                    this.props.recentKey = null;
                }
            });
        } else {
            this.ok && this.ok({});
        }       
    }

    public nextPage(e: any) {
        if (this.props.recentKey) {
            iterDb("file", this.props.tab, 10, this.props.recentKey, this.props.endKey, true, r => {
                console.log("code", r.code);
                let [modName, expt] = this.props.tab.split(".");
                let t = pi_modules[modName + ".s"].exports[expt];
                let primaryKey = t._$info.notes.get("primary");

                let bon1 = new BonBuffer(r.msg);
                let values = bon1.readArray(() => {
                    let bin = bon1.readBin();
                    // undefined 序列化为 0
                    if(equal(bin.buffer, new Uint8Array([0]).buffer)) {
                        return null
                    }
                    // 解析数据表
                    let b = new BonBuffer(bin);
                    let m = new t();
                    m.bonDecode(b);
                    return m;
                });

                console.log(values);

                if (values) {
                    values.splice(0, 1);
                }

                for(let v of values) {
                    this.props.datas.push([v[primaryKey], JSON.stringify(v)]);
                }
                this.paint();
                if(values.length) {
                    this.props.recentKey = values[values.length - 1][primaryKey];
                } else {
                    this.props.recentKey = null;
                }
            });
        } else {
            this.ok && this.ok({});
        }       
    }
}
