// tslint:disable-next-line:missing-jsdoc
import { popNew } from '../../../../pi/ui/root';
import { notify } from '../../../../pi/widget/event';
import { Widget } from '../../../../pi/widget/widget';

interface Props {
    title:any[];// 表格标题
    datas:any[];// 表数据
    selectList:any[];// 选择框列表
    allChecked:boolean;// 全选
    isChange:number;// 是否修改数据值
    currentRowData:any[];// 当前行的数据
    isAdd:number;// 是否是新增数据
}
// tslint:disable-next-line:completed-docs
export class Table extends Widget {
    public props:Props = {
        title:[],
        datas:[],
        selectList:[0,0,0,0,0,0],
        allChecked:false,
        isChange:-1,
        currentRowData:[],
        isAdd:-1
    };
    public setProps(props:any) {
        this.props = {
            ...props,
            selectList:[0,0,0,0,0,0],
            allChecked:false,
            currentRowData:[]
        };
        super.setProps(this.props);
        this.init();
    }
    public init() {
        this.props.currentRowData = this.props.datas[0];
    }
        // 全选整页
    public allChecked() {
        console.log('全选');
    }
    // 选中对应的行
    public checked(index:number) {
        console.log('选中对应的行');
    }
    // 行数据发生变化
    public rowDataChange(e:any) {
        const index = e.index;
        // 存在修改显示BUG 出现了双引号，刷新就没有了
        if (e.value !== '') {
            this.props.currentRowData[index] = JSON.parse(e.value);
        } else {
            this.props.currentRowData[index] = e.value;
        }
        // this.props.currentRowData[index] = e.value;
        console.log(e.value,e.index);
    }
    // 修改数据
    public save(e:any,index:number) {
        if (this.props.isAdd !== -1) {
            for (const key in this.props.currentRowData) {
                if (this.props.currentRowData[key] === '') {
                    popNew('pi-components-message-message', { type: 'error', content: '输入不能为空', center: true });

                    return;
                }
            }
        
            notify(e.node,'ev-changeData-table',{ value:this.props.currentRowData,types:2,index });

            return;
        }
        if (this.props.isChange !== -1) {
            // 保存数据
            this.props.isChange = -1;
            notify(e.node,'ev-changeData-table',{ value:this.props.currentRowData,types:1,index:index });
            this.paint();
            console.log(this.props.currentRowData);
        } else {
            // 修改数据
            this.props.isChange = index;
            this.props.currentRowData = this.props.datas[index];
        }
        this.paint();
    }
    // 删除数据
    public remove(e:any,index:number) {
        notify(e.node,'ev-changeData-table',{ types:0,index });
    }
}
