/**
 * 数据库筛选
 */

// ================================================ 导入
import { notify } from '../../../../pi/widget/event';
import { Widget } from '../../../../pi/widget/widget';

// ================================================ 导出

interface Props {
    optionList:any[];// 选项列表
    checked:number; // 选中的下标
    show:boolean;// 是否显示列表  1显示 0不显示
}

// tslint:disable-next-line:completed-docs
export class DatabaseFilter extends Widget {
    public props:Props = {
        optionList:[],
        checked:1,
        show:false
    };
    public setProps(props:any) {
        this.props = {
            ...props,
            checked:1,
            show:false
        };
        super.setProps(this.props);
    }
    // 点击展开
    public expand() {
        console.log(this.props);
        this.props.show = true;
        this.paint();
    }
    // 选择筛选条件
    public select(e:any,index:number) {
        this.props.checked = index;
        notify(e.node,'ev-database-change',{ value:this.props.optionList[index],index:index }); 
        this.props.show = false;
        this.paint();
    }
}