/**
 * Server configuration
 */
/**
 * 服务器配置
 */
import { cfgMgr } from '../../../pi/util/cfg';
import { AsyncCfg, HttpsCfg, MqttCfg, NetCfg, RpcCfg, TlsNetMgr, NetCfg_Enum, TlsNetCfg, HttpsTlsCfg, RawNetMgr, RawNetCfg } from '../../../pi_pt/init/server_cfg.s';
// 启动http与ws
let rawNetMgr = new RawNetMgr("rawNetMgr", []);
let rawNetCfg = new NetCfg(NetCfg_Enum.Raw, new RawNetCfg("0.0.0.0:1234", "tcp", true, rawNetMgr, []));
let mqttCfg = new MqttCfg(rawNetCfg, 1024*1024, 500 * 1000, "mqttServer", []);
let rpcCfg = new RpcCfg(mqttCfg, "rpcServer", ["mqttServer"]);
let asyncCfg = new AsyncCfg([]);
let httpsCfg = new HttpsCfg("0.0.0.0", 80, 5000, 10000, "../dst/", "../src/");

cfgMgr.set(RawNetMgr._$info.name, new Map<number,any>([[0, rawNetMgr]]));
cfgMgr.set(NetCfg._$info.name, new Map<number,any>([[0, rawNetCfg]]));
cfgMgr.set(MqttCfg._$info.name, new Map<number, any>([[0, mqttCfg]]));
cfgMgr.set(RpcCfg._$info.name, new Map<number, any>([[0, rpcCfg]]));
cfgMgr.set(AsyncCfg._$info.name, new Map<number,any>([[0, asyncCfg]]));
cfgMgr.set(HttpsCfg._$info.name, new Map<number,any>([[0, httpsCfg]]));

// import { cfgMgr } from '../../../pi/util/cfg';
// import { AsyncCfg, MqttCfg, NetCfg, RpcCfg, TlsNetMgr, NetCfg_Enum, TlsNetCfg, HttpsTlsCfg } from '../../../pi_pt/init/server_cfg.s';

// let tlsNetMgr = new TlsNetMgr("tlsNetMgr", 16 * 1024, []);//最大是16*1024
// let tlsNetCfg = new NetCfg(NetCfg_Enum.Tls, new TlsNetCfg("0.0.0.0:1234", "tcp", "./1595835_herominer.net.pem", "./1595835_herominer.net.key", true, tlsNetMgr, []));
// let mqttCfgTls = new MqttCfg(tlsNetCfg, 1024 * 1024, 500 * 1000, "mqttServer", []);
// let rpcCfgTls = new RpcCfg(mqttCfgTls, "rpcServer", ["mqttServer"]);
// const asyncCfg = new AsyncCfg([]);
// let httpsTlsCfg = new HttpsTlsCfg("0.0.0.0", 443, 5000, 10000, "../dst/", "../src/", "./1595835_herominer.net.pem", "./1595835_herominer.net.key");

// cfgMgr.set(TlsNetMgr._$info.name, new Map<number, any>([[0, tlsNetMgr]]));
// cfgMgr.set(NetCfg._$info.name, new Map<number, any>([[0, tlsNetCfg]]));
// cfgMgr.set(MqttCfg._$info.name, new Map<number, any>([[0, mqttCfgTls]]));
// cfgMgr.set(RpcCfg._$info.name, new Map<number, any>([[0, rpcCfgTls]]));
// cfgMgr.set(AsyncCfg._$info.name, new Map<number, any>([[0, asyncCfg]]));
// cfgMgr.set(HttpsTlsCfg._$info.name, new Map<number, any>([[0, httpsTlsCfg]]));
